// MoI Nodeedit
// Factories v.0.2 - Max Smirnov, 2015
// litegraph.js library (c) Javi Agenjo http://tamats.com

function selectBylist(namesList) {
    var selectedObjects = moi.geometryDatabase.createObjectList();
    moi.geometryDatabase.deselectAll();					//
    for (var i = 0; i < namesList.length; i++)
    {
        moi.geometryDatabase.selectNamed(namesList[i]);
    }
    selectedObjects = moi.geometryDatabase.getSelectedObjects();
//    selectedObjects.setProperty('displayMode', 1);
//    selectedObjects.setProperty('selected', 0);
    moi.geometryDatabase.deselectAll();
    return selectedObjects;
}

function createFrameByLines(basePt, DirLineU, DirLineV) //mathpoint,object,object
{
    var uPtStart = DirLineU.getStartPt(); //Anfangspunkt der Kurve erzeugen
    var uPtEnd = DirLineU.getEndPt();
    var vPtStart = DirLineV.getStartPt();
    var vPtEnd = DirLineV.getEndPt();
    // create point object to array

    var dirU = moi.VectorMath.createPoint(
            uPtEnd.x - uPtStart.x,
            uPtEnd.y - uPtStart.y,
            uPtEnd.z - uPtStart.z
            );
    var dirV = moi.VectorMath.createPoint(
            vPtEnd.x - vPtStart.x,
            vPtEnd.y - vPtStart.y,
            vPtEnd.z - vPtStart.z
            );

    var outFrame = moi.VectorMath.createFrame(basePt, dirU, dirV);

    return outFrame;
}

function deleteObjects(nameArray)
{
    moi.geometryDatabase.deselectAll();
    if (nameArray.length > 0)
    {
        var deleteList = moi.geometryDatabase.createObjectList();
        for (var i = 0; i < nameArray.length; i++)
        {
            moi.geometryDatabase.selectNamed(nameArray[i]);
        }
        deleteList = moi.geometryDatabase.getSelectedObjects();

        var deleteOldFaceFac = moi.command.createFactory('delete');
        deleteOldFaceFac.setInput(0, deleteList);
        deleteOldFaceFac.calculate();
        deleteOldFaceFac.commit();
        ///// cleaning up faceList
        while (nameArray.length > 0)
        {
            nameArray.pop();
        }
    }
}

function NormalilzeVA(VA, val)
{
    var nav = new Array();
    var max = VA[0];
    for (var i = 0; i < VA.length; i++) {
        if (VA[i] > max)
            max = VA[i];
    }
    for (var i = 0; i < VA.length; i++) {

        if (max != 0)
            nav[i] = VA[i] / max * val;
    }
    return nav;
}
// kmrqus
function checkSMI(val)
{	//test for strictly monotonic increasing
    for (var i = 0; i < val.length - 2; i++) {
        if (val[i] > val[i + 1])
        {
            return false;
        }

        return true;
    }
}

/**
 * 
 * @param {moi.geometryDatabase.ObjectList} crvObj
 * @param {array of numbers} valArray
 * @param {moi.geometryDatabase.ObjectList} objList
 * @param {String - "Flat"/"Freeform"} rotMod
 * @param {Number 10000 a good choice} divValue
 * @returns {Array|approxCurveDivision.selectedPts}
 */
/*function approxCurveDivision(crvObj, valArray, objList, rotMod, divValue)
{

    var selectedPts = moi.geometryDatabase.createObjectList();
    var burstPts = moi.geometryDatabase.createObjectList();
    var burstPtsFac = moi.command.createFactory('arraycurve'); // a single value for homogenous division

    burstPtsFac.setInput(0, objList);
    burstPtsFac.setInput(1, crvObj); //  the profilecurve
    burstPtsFac.setInput(2, 'NumItems'); // array mode
    burstPtsFac.setInput(3, divValue); // Number of items
    burstPtsFac.setInput(5, rotMod); // rotation Mode Flat or Freeform
    burstPts = burstPtsFac.calculate();
    burstPtsFac.cancel();
//Normalize DivNumProfile
    var nva = NormalilzeVA(valArray, 1);
//End Normalize DivNumProfile

//evaluate the the index of the burstPts corresponding to the normalized value
    var idx = new Array();
    for (var i = 0; i < valArray.length; i++)
    {//if(crvObj.isClosed == true)
        idx[i] = (Math.round(nva[i] * divValue) - 2);
        if (idx[i] < 0)
            idx[i] = 0;
    }
//End evaluate the the index of the burstPts corresponding to the normalized value
//Pick the Points from burstPts and store them in the curvePts

    for (var n = 0; n < idx.length; n++)
    {
        if (burstPts.length > idx[n] && idx[n] > 0)
            selectedPts.addObject(burstPts.item(idx[n]));
    }
    return selectedPts;

}
*/
// stolen from Max:-)
function crvlength(crvs)
{
    var len = 0.0;
    for (var i = 0; i < crvs.length; ++i)
        len += crvs.item(i).getLength();
    return len;
}
// example from http://stackoverflow.com/questions/6248666/how-to-generate-short-uid-like-ax4j9z-in-js
/*
 * function generates a UID string (unique identity) as a chain of random characters and numbers
 */
function getUID(len) {
    var chars = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789',
            out = '';
    for (var i = 0, clen = chars.length; i < len; i++)
    {
        out += chars.substr(0 | Math.random() * clen, 1);
    }

// ensure that the uid is unique for this page
    return getUID.uids[out] ? getUID(len) : (getUID.uids[out] = out);
}
getUID.uids = {};

(function () {
    // ########## Join ###########
function objJoin()
{
//	this.size = [40,20];
	this.addInput("Objects","objectlist");
	this.addOutput("Out","objectlist");
}

objJoin.title = "Join";
objJoin.desc = "Join";

objJoin.prototype.onExecute = function()
{
	var baseObj = this.getInputData(0, moi.geometryDatabase.createObjectList());
	var output = moi.geometryDatabase.createObjectList();
	if (baseObj.length > 1 )
	{ 
	var joinFac = moi.command.createFactory('join');
        joinFac.setInput(0, baseObj);
        output = joinFac.calculate();
        joinFac.cancel();
	}
	this.setOutputData(0, output);
}

LiteGraph.registerNodeType("SubD/objJoin", objJoin);
// ########## end Join ###########

/////////// Selectable CenterPlane ///////////////

    /*
     * Node for a run-time selectable plane. it can be picked as a support for the simpleBridge function
     */
    function selCenterPlane()
    {
//	this.size = [60,20];
        this.addInput("Center", "pointarray");
        this.addInput("Width", "numarray");
        this.addInput("Hight", "numarray");
        this.addOutput("Out", "objectlist");
        this.properties = {width:[10], hight:[10], planeName: '', selectable:["true","true","false"], visible:["true","true","false"] };
        this.tempObjects = moi.geometryDatabase.createObjectList();
    }

    selCenterPlane.title = "selCenterPlane";
    selCenterPlane.desc = "selCenterPlane";

    selCenterPlane.prototype.onPropertyChange = function ()
    {
    }
    selCenterPlane.prototype.onAdded = function ()
    {
//        this.properties.oldFaceList = new Array(); // contains the names of the generated Faces for delete them, for a rerun

        if (this.properties.planeName == '') {
            this.properties.planeName = getUID(6);
        }


    }


    selCenterPlane.prototype.onExecute = function ()
    {
        moi.geometryDatabase.removeObjects(this.tempObjects); // clear from old faces from a previous run
        this.tempObjects = moi.geometryDatabase.createObjectList(); //reset of the tempObjectsList
        var inpArray = this.getInputData(0, new pointArray(true));
        var center = inpArray.getFrame(0);
        this.properties.width = this.getInputData(1, this.properties.width);
        this.properties.hight = this.getInputData(2, this.properties.hight);
        var planeFac = moi.command.createFactory('planecenter');
        planeFac.setInput(0, center);
        planeFac.setInput(2, this.properties.width[0]);
        planeFac.setInput(3, this.properties.hight[0]);
        var output = planeFac.calculate();
        planeFac.cancel();
        output.item(0).name = this.properties.planeName;
        if (this.properties.selectable[0] === "true")
        {
            this.tempObjects.addObject(output.item(0).clone());
            moi.geometryDatabase.addObjects(this.tempObjects); // thowing the polyfaces to the database, so they are selectable!!!
            if (this.properties.visible[0] === "false")
                for (var i = 0; i < this.tempObjects.length; i++) {
                    this.tempObjects.item(i).hidden = true;
                }
        }

        this.setOutputData(0, output);
    }
    selCenterPlane.prototype.onApply = function ()
    {
        moi.geometryDatabase.removeObjects(this.tempObjects); // clear from old faces from a previous run
//        deleteObjects(this.properties.oldFaceList);
//        this.onExecute();
    }
    selCenterPlane.prototype.onDrawBackground = function (ctx) {
        this.outputs[0].label = this.properties.planeName;
    }

    LiteGraph.registerNodeType("SubD/selCenterPlane", selCenterPlane);
/////////// End Selectable CenterPlane ///////////////7

/////////////////////////////////////////////////////
//
//node convertCurveToPoly
////////////////////////////////////////////////////
    function convertCurveToPoly()
    {
//        this.arraycurvetest = true;
        this.debug = true;
        this.maxsize = [70, 70]; // following the inputs
        this.addInput("profile", "objectlist"); // [0] profile
        this.addInput("Div Profile", "numarray"); //  [1] Division Number of Profile - 
//        this.addInput("BasePt for Closed Profile", "objectlist"); //[2]
        this.addOutput("Out", "objectlist"); //[0]
        this.properties = {Division:[12]};
        this.DivNumProfile = new Array();
    }
    convertCurveToPoly.title = "convertCurveToPoly";
    convertCurveToPoly.desc = "convertCurveToPoly";
    convertCurveToPoly.prototype.onAdded = function ()
    {
    }
    convertCurveToPoly.prototype.onExecute = function ()
    {
        this.profilePts = moi.geometryDatabase.createObjectList();
        var profile = this.getInputData(0, moi.geometryDatabase.createObjectList());
        this.properties.Division = this.getInputData(1, this.properties.Division);
//#########Profile Startpoint############
        if (profile.length > 0)
        {

                var profileStartPtFac = moi.command.createFactory('point'); // genertating the startpoint of the profile
                profileStartPtFac.setInput(0, profile.item(0).getStartPt()); //
                var profileStartPt = profileStartPtFac.calculate(); //
                profileStartPtFac.cancel();
//            }

//############End Profile Startpoint#########

//############Start Profile points calculation#########

            if (this.properties.Division.length > 1 && checkSMI(this.properties.Division)) //Here with multiple Values in this.DivNumProfile
            {
                var profilePts = CurveDivision(profile.item(0), this.properties.Division, profileStartPt, "Freeform"); //CurveObject, Array of Values to divide the Curve, Oblectlist to distribute on the curve, base division value!
            } else                                                                      //Here with a single Values in this.DivNumProfile
            {
                var profilePtsFac = moi.command.createFactory('arraycurve'); // a single value for homogenous division
                profilePtsFac.setInput(0, profileStartPt); // geomobject
                profilePtsFac.setInput(1, profile.item(0)); //  the profilecurve
                profilePtsFac.setInput(2, 'NumItems'); // array mode
                profilePtsFac.setInput(3, this.properties.Division[0]); // Number of items

                var profilePts = profilePtsFac.calculate(); ////var ?????
                profilePtsFac.cancel();
            }

////////////// Create the approximated Profile Curve as Polyline
//var cSP=moi.vectorMath.createPoint(curveStartPt.pt.x);
            var profilePolyFac = moi.command.createFactory('Polyline');
            profilePolyFac.createInput('point');
            profilePolyFac.setInput(0, profileStartPt.item(0).pt);
            var prdiv; // difference between open an closed Profiles in the arrayccurve factory!!!!
            if (profile.item(0).isClosed === true && this.DivNumProfile.length > 1) {
                prdiv = profilePts.length - 1;
            } else {
                prdiv = profilePts.length;
            }
            for (var n = 0; n < prdiv; n++)
            {
                profilePolyFac.createInput('point');
                profilePolyFac.setInput(profilePolyFac.numInputs - 1, profilePts.item(n).pt);
            }
            if (profile.item(0).isClosed === true)                                // "save" closeup of of a closed profilecurve 
            {
                profilePolyFac.createInput('point');
                profilePolyFac.setInput(profilePolyFac.numInputs - 1, profileStartPt.item(0).pt);
            }
            var basePolyProfile = profilePolyFac.calculate();
            if (basePolyProfile.length > 0)
                basePolyProfile.item(0).name = "Willi";
            this.setOutputData(0, basePolyProfile);
            profilePolyFac.cancel();
        }
//////////////////////////////End Create the approximated Profile Curve as Polyline/////////////////////////
    }
    LiteGraph.registerNodeType("SubD/convertCurveToPoly", convertCurveToPoly);
////////////////////////////

// node polyLoft
////////////////////////////////////////////////


    function polyLoft()
    {
        this.size = [60, 20];
        this.addInput("Curves", "objectlist");
        this.addOutput("Out1", "objectlist");
        this.properties = {objName: '', selectable:["true","true","false"], visible:["true","true","false"]};
        this.tempObjects = moi.geometryDatabase.createObjectList();
    }

    polyLoft.title = "polyLoft";
    polyLoft.desc = "polyLoft";
    polyLoft.prototype.setValue = function (v)
    {
        if (typeof (v) == "string")
            this.properties.objName = v;
        this.properties.objName = v;
        this.setDirtyCanvas(true);
    }

    polyLoft.prototype.onPropertyChange = function ()
    {
        this.outputs[0].label = this.properties.objName;
        this.onExecute();
    }
    polyLoft.prototype.onAdded = function ()
    {


        if (this.properties.objName == '') {
            this.properties.objName = getUID(6);
        }


    }

    polyLoft.prototype.onExecute = function ()
    {
        moi.geometryDatabase.removeObjects(this.tempObjects); // clear from old faces from a previous run
        this.tempObjects = moi.geometryDatabase.createObjectList(); //reset of the tempObjectsList
        var inObj = this.getInputData(0, moi.geometryDatabase.createObjectList());
        var output = moi.geometryDatabase.createObjectList();
        if (inObj.length > 2)
        {
            for (var i = 0; i < inObj.length - 1; i++)
            {
                var curvePair = moi.geometryDatabase.createObjectList();
                var truncated = moi.geometryDatabase.createObjectList();
                var polyFaces = moi.geometryDatabase.createObjectList();
                curvePair.addObject(inObj.item(i));
                curvePair.addObject(inObj.item(i + 1));
                var truncatedFac = moi.command.createFactory('loft');
                truncatedFac.setInput(0, curvePair);
                truncatedFac.setInput(2, 'Straight');
                truncatedFac.setInput(3, false);
                truncatedFac.setInput(4, false);
                truncated = truncatedFac.calculate();
                truncatedFac.cancel();
                var polyFaceFac = moi.command.createFactory('separate');
                polyFaceFac.setInput(0, truncated);
                polyFaces = polyFaceFac.calculate();
                polyFaceFac.cancel();
                for (var j = 0; j < polyFaces.length; j++)
                {
                    polyFaces.item(j).name = this.properties.objName + "_R" + i + "_C" + j;
                    this.tempObjects.addObject(polyFaces.item(j));
                    output.addObject(polyFaces.item(j).clone());
                }
            }
            var loop0 = inObj.item(0).clone();
            var loopN = inObj.item(inObj.length - 1).clone();
            loop0.name = this.properties.objName + "_L0";
            loopN.name = this.properties.objName + "_LN";
            this.tempObjects.addObject(loop0);
            this.tempObjects.addObject(loopN);
        }

///////////////////////////////////
        if (this.properties.selectable[0] === "true")
        {
            moi.geometryDatabase.addObjects(this.tempObjects); // thowing the polyfaces to the database, so they are selectable!!!
            if (this.properties.visible[0] === "false")
                for (var i = 0; i < this.tempObjects.length; i++) {
                    this.tempObjects.item(i).hidden = true;
                }
        }
        this.setOutputData(0, output);
    }

    polyLoft.prototype.onApply = function ()
    {
        moi.geometryDatabase.removeObjects(this.tempObjects); // clear from old faces from a previous run
    }


    LiteGraph.registerNodeType("SubD/polyLoft", polyLoft);
/////////////////////////////////////////////////////////
//
//node simpleBridge
/////////////////////////////////////////////////////////

    function simpleBridge()
    {
        this.size = [60, 20];
        this.addInput("FaceSet0", "objectlist");
        this.addInput("FaceSet1", "objectlist");
        this.addOutput("Out1", "objectlist");
        this.properties = {objName: '', face0: '', face1: '', selectable:["true","true","false"] , visible:["true","true","false"]};
        this.inputobjects = moi.geometryDatabase.createObjectList();
        this.tempObjects = moi.geometryDatabase.createObjectList();
    }

    simpleBridge.title = "simpleBridge";
    simpleBridge.desc = "simpleBridge";
    simpleBridge.prototype.setValue = function (v)
    {
        if (typeof (v) == "string")
            this.properties.objName = v;
        this.properties.objName = v;
        this.setDirtyCanvas(true);
    }

    simpleBridge.prototype.onMouseDown = function () //reselection of the faces for the bridge
    {
        this.inputobjects = moi.geometryDatabase.createObjectList();
        this.inputobjects = moi.geometryDatabase.getSelectedObjects(); // stores the selected faces (2 Faces as start and end of the loft)
        if ((this.inputobjects.length > 1)
                && (this.inputobjects.item(0).name != '')
                && (this.inputobjects.item(1).name != '')
                )
        {
            this.properties.face0 = this.inputobjects.item(0).name; //storing the names of the selected objects
            this.properties.face1 = this.inputobjects.item(1).name;
            this.onExecute();
        }
    }

    simpleBridge.prototype.onPropertyChange = function ()
    {
//        this.inputobjects = selectBylist(this.properties.faces);  //very important for for update on change
        this.inputobjects = moi.geometryDatabase.createObjectList();
        moi.geometryDatabase.deselectAll();
        moi.geometryDatabase.selectNamed(this.properties.face0);
        moi.geometryDatabase.selectNamed(this.properties.face1);
        this.inputobjects = moi.geometryDatabase.getSelectedObjects();
        moi.geometryDatabase.deselectAll();
        this.outputs[0].label = this.properties.objName;
        this.computeSize();
    }
    simpleBridge.prototype.onAdded = function ()
    {
        this.inputobjects = moi.geometryDatabase.createObjectList();
        this.properties.objName = getUID(6); // basename for the simpleBridge faces
        this.inputobjects = moi.geometryDatabase.getSelectedObjects(); // stores the selected faces (2 Faces as start and end of the loft)
        if ((this.inputobjects.length > 1)
                && (this.inputobjects.item(0).name != '')
                && (this.inputobjects.item(1).name != '')
                )
        {

            this.properties.face0 = this.inputobjects.item(0).name; //storing the names of the selected objects
            this.properties.face1 = this.inputobjects.item(1).name;

        }
    }

    simpleBridge.prototype.onApply = function ()
    {
        moi.geometryDatabase.removeObjects(this.tempObjects); // clear from old faces from a previous run

    }

    simpleBridge.prototype.onExecute = function ()
    {   // cleaning up old faces
        var facesSet0 = this.getInputData(0, moi.geometryDatabase.createObjectList()); // lists of the Facessets which connected by the bridge
        var facesSet1 = this.getInputData(1, moi.geometryDatabase.createObjectList());
        this.inputobjects = moi.geometryDatabase.createObjectList();
        moi.geometryDatabase.removeObjects(this.tempObjects); // clear from old faces from a previous run
        this.tempObjects = moi.geometryDatabase.createObjectList(); //reset of the tempObjectsList
        if (this.properties.face0 != '' && this.properties.face1 != '')
        {
            moi.geometryDatabase.deselectAll();
            moi.geometryDatabase.selectNamed(this.properties.face0);
            moi.geometryDatabase.selectNamed(this.properties.face1);
            this.inputobjects = moi.geometryDatabase.getSelectedObjects();
            moi.geometryDatabase.deselectAll();
            var originXYZ = moi.VectorMath.createPoint(0, 0, 0); //Helppoint for a identical copy
            var faceEdges0 = moi.geometryDatabase.createObjectList(); //stores the outer edges/boundaries of the selected face
            var faceEdges1 = moi.geometryDatabase.createObjectList();
            var faceLoop0 = moi.geometryDatabase.createObjectList(); //stores the loop as a polyline
            var faceLoop1 = moi.geometryDatabase.createObjectList();
            var curvePair = moi.geometryDatabase.createObjectList(); //objectlist with both loops
            var truncated = moi.geometryDatabase.createObjectList(); //stores the loftresult from the loops
            var polyFaces = moi.geometryDatabase.createObjectList();
            var output = moi.geometryDatabase.createObjectList();
//                faceEdges0.addObject(inputobjects.item(0).getEdges());
//                faceEdges1.addObject(inputobjects.item(1).getEdges());
            var faceEdges0Fac = moi.command.createFactory('copy');
            faceEdges0Fac.setInput(0, this.inputobjects.item(0).getEdges());
            faceEdges0Fac.setInput(1, originXYZ);
            faceEdges0Fac.setInput(2, originXYZ);
            faceEdges0Fac.setInput(3, true);
            faceEdges0 = faceEdges0Fac.calculate();
            faceEdges0Fac.cancel();
            var faceEdges1Fac = moi.command.createFactory('copy');
            faceEdges1Fac.setInput(0, this.inputobjects.item(1).getEdges());
            faceEdges1Fac.setInput(1, originXYZ);
            faceEdges1Fac.setInput(2, originXYZ);
            faceEdges1Fac.setInput(3, true);
            faceEdges1 = faceEdges1Fac.calculate();
            faceEdges1Fac.cancel();
            var faceLoop0Fac = moi.command.createFactory('join');
            faceLoop0Fac.setInput(0, faceEdges0);
            faceLoop0 = faceLoop0Fac.calculate();
            faceLoop0Fac.cancel();
            var faceLoop1Fac = moi.command.createFactory('join');
            faceLoop1Fac.setInput(0, faceEdges1);
            faceLoop1 = faceLoop1Fac.calculate();
            faceLoop1Fac.cancel();
            curvePair.addObject(faceLoop0.item(0));
            curvePair.addObject(faceLoop1.item(0));
            var truncatedFac = moi.command.createFactory('loft');
            truncatedFac.setInput(0, curvePair);
            truncatedFac.setInput(2, 'Straight');
            truncatedFac.setInput(3, false);
            truncatedFac.setInput(4, false);
            truncated = truncatedFac.calculate();
            truncatedFac.cancel();
            var polyFaceFac = moi.command.createFactory('separate'); //smashing the loft into single faces
            polyFaceFac.setInput(0, truncated);
            polyFaces = polyFaceFac.calculate();
            polyFaceFac.cancel();
            for (var j = 0; j < polyFaces.length; j++)
            {
                polyFaces.item(j).name = this.properties.objName + "_C" + j; // naming of the faces
                this.tempObjects.addObject(polyFaces.item(j).clone());
                output.addObject(polyFaces.item(j)); //adding to the output
            }

            for (var n = 0; n < facesSet0.length; n++)                      //adding the input facesets to the output also
            {
                if (facesSet0.item(n).name != this.properties.face0 && facesSet0.item(n).name != this.properties.face1) // filter for the faces that will be holes for bridge
                    output.addObject(facesSet0.item(n));
            }
            for (var k = 0; k < facesSet1.length; k++)
            {
                if (facesSet1.item(k).name != this.properties.face0 && facesSet1.item(k).name != this.properties.face1) // filter for the faces that will be holes for bridge
                    output.addObject(facesSet1.item(k));
            }
            if (this.properties.selectable[0] === "true")
            {
                moi.geometryDatabase.addObjects(this.tempObjects); // thowing the polyfaces to the database, so they are selectable!!!
                if (this.properties.visible[0] === "false")
                    for (var i = 0; i < this.tempObjects.length; i++) {
                        this.tempObjects.item(i).hidden = true;
                    }
            }

            this.setOutputData(0, output);
            this.inputobjects = moi.geometryDatabase.createObjectList();
        } else {
            moi.UI.alert("Oops, something went wrong! Do you have loaded the file were the matching geometry is in? Did you preselected the faces before you created the node? What can we do? Select two named faces an click on the node to reconnect:-)");
        }
    }

    simpleBridge.prototype.onApply = function ()
    {

    }


    simpleBridge.prototype.onDrawBackground = function (ctx)
    {
        this.inputs[0].label = this.properties.face0;
        this.inputs[1].label = this.properties.face1;
    }
    
    simpleBridge.prototype.onRemoved = function ()
    {
      moi.geometryDatabase.removeObjects(this.tempObjects); 
    }
    LiteGraph.registerNodeType("SubD/simpleBridge", simpleBridge);
////////////////////// Connection /////////////////

    function connection()
    {
        this.size = [60, 20];
        this.addInput("FaceSet0", "objectlist");
        this.addInput("FaceSet1", "objectlist");
        this.addOutput("Out1", "objectlist");
        this.properties = {objName: '', selObjects: new Array, selectable:["true","true","false"], visible:["true","true","false"]};
        this.inputobjects = moi.geometryDatabase.createObjectList();
        this.tempObjects = moi.geometryDatabase.createObjectList();
    }

    connection.title = "connection";
    connection.desc = "connection";
    connection.prototype.onAdded = function ()
    {
        var allNamed = false;
        this.properties.objName = getUID(6); // basename for the connection faces
        this.inputobjects = moi.geometryDatabase.getSelectedObjects(); // stores the selected faces (2 Faces as start and end of the loft)
        for (var n = 0; n < this.inputobjects.length; n++)
        {
            if (this.inputobjects.item(n).name != '')
            {
                allNamed = true;
                this.properties.selObjects.push(this.inputobjects.item(n).name); //storing the names of the selected objects
            } else {
                allNamed = false;
                break;
            }
        }
        this.onExecute();
    }

    connection.prototype.setValue = function (v)
    {

    }

    connection.prototype.onPropertyChange = function ()
    {

    }

    connection.prototype.onExecute = function ()
    {
        var tolerance = moi.GeometryDatabase.tolerance;
        this.inputobjects = moi.geometryDatabase.createObjectList();
        var loops = moi.geometryDatabase.createObjectList();
        var output = moi.geometryDatabase.createObjectList();
        var joinedInput = moi.geometryDatabase.createObjectList();
        var joinedFacesEdges = moi.geometryDatabase.createObjectList();
        var joinedFacesLoops = moi.geometryDatabase.createObjectList();
        this.inputobjects = selectBylist(this.properties.selObjects);
        loops = this.inputobjects.getCurves();
        var facebundles = this.inputobjects.getSingleFaceBReps();
        if (loops.length < 2)
        {
            var joinFac = moi.command.createFactory('join');
            joinFac.setInput(0, facebundles);
            joinedInput = joinFac.calculate();
            joinFac.cancel();
//         this.outputs[0].label = this.inputobjects.item(0).GeomObjectEnum;
            for (var i = 0; i < joinedInput.length; i++)
            {
                var singleEdges = joinedInput.item(i).getNakedEdges();
                for (var j = 0; j < singleEdges.length; j++)
                {
                    joinedFacesEdges.addObject(singleEdges.item(j)); // getOpenBReps getSubObjects().getBReps()..getNackedEdges()
                }
            }
            var joinFac = moi.command.createFactory('join');
            joinFac.setInput(0, joinedFacesEdges);
            joinedFacesLoops = joinFac.calculate();
            joinFac.cancel();
            for (var i = 0; i < joinedInput.length; i++)
            {
                loops.addObject(joinedFacesLoops.item(i));
            }
        }

/// Separate the loops an break in lineeelements
        var loop0 = moi.geometryDatabase.createObjectList();
        var loop1 = moi.geometryDatabase.createObjectList();
        loop0.addObject(loops.item(0));
        loop1.addObject(loops.item(1));
        var loop0Elements = moi.geometryDatabase.createObjectList();
        var loop1Elements = moi.geometryDatabase.createObjectList();
        var loop0ElementsFac = moi.command.createFactory('separate');
        loop0ElementsFac.setInput(0, loop0);
        loop0Elements = loop0ElementsFac.calculate();
        loop0ElementsFac.cancel();
        var loop1ElementsFac = moi.command.createFactory('separate');
        loop1ElementsFac.setInput(0, loop1);
        loop1Elements = loop1ElementsFac.calculate();
        loop1ElementsFac.cancel();
/// end Separate the loops
/// getting a vertexsequence for both loops
        var loop0Points = new Array();
        var loop1Points = new Array();
        loop0Points.push(loop0Elements.item(0).getStartPt());
        loop0Points.push(loop0Elements.item(0).getEndPt());
        loop0Elements.removeObject(loop0Elements.item(0))
        while (loop0Elements.length > 1)
        {
            for (var i = 0; i < loop0Elements.length; i++)
            {
                var startPt = loop0Elements.item(i).getStartPt();
                var endPt = loop0Elements.item(i).getEndPt();
                if (moi.VectorMath.distance(loop0Points[loop0Points.length - 1], startPt) < tolerance)
                {
                    loop0Points.push(endPt);
                    loop0Elements.removeObject(loop0Elements.item(i));
                    break;
                }
                if (moi.VectorMath.distance(loop0Points[loop0Points.length - 1], endPt) < tolerance)
                {
                    loop0Points.push(startPt);
                    loop0Elements.removeObject(loop0Elements.item(i));
                    break;
                }
            }

        }
        loop1Points.push(loop1Elements.item(0).getStartPt());
        loop1Points.push(loop1Elements.item(0).getEndPt());
        loop1Elements.removeObject(loop1Elements.item(0))
        while (loop1Elements.length > 1)
        {
            for (var i = 0; i < loop1Elements.length; i++)
            {
                var startPt = loop1Elements.item(i).getStartPt();
                var endPt = loop1Elements.item(i).getEndPt();
                if (moi.VectorMath.distance(loop1Points[loop1Points.length - 1], startPt) < tolerance)
                {
                    loop1Points.push(endPt);
                    loop1Elements.removeObject(loop1Elements.item(i));
                    break;
                }
                if (moi.VectorMath.distance(loop1Points[loop1Points.length - 1], endPt) < tolerance)
                {
                    loop1Points.push(startPt);
                    loop1Elements.removeObject(loop1Elements.item(i));
                    break;
                }
            }

        }

    }
    connection.prototype.onApply = function ()
    {

    }

    connection.prototype.onDrawBackground = function (ctx)
    {
    }

    connection.prototype.onMouseDown = function ()
    {
    }

    LiteGraph.registerNodeType("SubD/connection", connection);
})();